### Hierarchy

- WebApp
  - SampleApp

### Implements

- IDisposable

## Index

### Constructors

- constructor

### Properties

- appReady
- dispatcher
- parent
- screen

### Accessors

- contextId
- global
- parentElement
- root
- theme
- url

### Methods

- broadcast
- callLater
- createBusyIndicator
- dispose
- get
- getValue
- installScript
- installStyleSheet
- invokeReady
- main
- newScope
- onError
- onReady
- put
- resolve
- runAsync
- subscribe
- syncUrl
- updateDefaultStyle
- waitForPendingCalls

## Constructors

### constructor

- new SampleApp(): SampleApp

- Inherited from WebApp.constructor

  Overrides App.constructor

  - Defined in src/web/WebApp.ts:64

  #### Returns SampleApp

## Properties

### appReady

appReady: boolean = false

Inherited from App.appReady

- Defined in src/App.ts:45

This must be set explicitly as it can be used outside to detect if app is ready. This will not be set automatically by framework.

### dispatcher

dispatcher: AtomDispatcher

Inherited from App.dispatcher

- Defined in src/App.ts:37

### parent

parent: ServiceProvider

Inherited from ServiceProvider.parent

- Defined in src/di/ServiceProvider.ts:17

### screen

screen: IScreen

Inherited from App.screen

- Defined in src/App.ts:39

## Accessors

### contextId

- get contextId(): string

- Inherited from WebApp.contextId

  Overrides App.contextId

  - Defined in src/web/WebApp.ts:58

  #### Returns string

### global

- get global(): ServiceProvider

- Inherited from ServiceProvider.global

  - Defined in src/di/ServiceProvider.ts:13

  #### Returns ServiceProvider

### parentElement

- get parentElement(): HTMLElement

- Inherited from WebApp.parentElement

  - Defined in src/web/WebApp.ts:17

  #### Returns HTMLElement

### root

- get root(): any
- set root(v: any): void

- Inherited from WebApp.root

  - Defined in src/web/WebApp.ts:22

  #### Returns any

- Inherited from WebApp.root

  - Defined in src/web/WebApp.ts:26

  #### Parameters

  - ##### v: any

  #### Returns void

### theme

- get theme(): AtomStyleSheet
- set theme(v: AtomStyleSheet): void

- Inherited from WebApp.theme

  - Defined in src/web/WebApp.ts:48

  #### Returns AtomStyleSheet

- Inherited from WebApp.theme

  - Defined in src/web/WebApp.ts:52

  #### Parameters

  - ##### v: AtomStyleSheet

  #### Returns void

### url

- get url(): AtomUri
- set url(v: AtomUri): void

- Inherited from App.url

  - Defined in src/App.ts:55

  #### Returns AtomUri

- Inherited from App.url

  - Defined in src/App.ts:59

  #### Parameters

  - ##### v: AtomUri

  #### Returns void

## Methods

### broadcast

- broadcast(channel: string, data: any): void

- Inherited from App.broadcast

  - Defined in src/App.ts:140

  Broadcast given data to channel, only within the current window.

  memberof

    AtomDevice

  #### Parameters

  - ##### channel: string

  - ##### data: any

  #### Returns void

### callLater

- callLater(f: function): void

- Inherited from App.callLater

  - Defined in src/App.ts:91

  #### Parameters

  - ##### f: function

    - - (): void

      - #### Returns void

### createBusyIndicator

- createBusyIndicator(): IDisposable

- Inherited from App.createBusyIndicator

  - Defined in src/App.ts:81

  #### Returns IDisposable

### dispose

- dispose(): void

- Implementation of IDisposable.dispose

  Inherited from ServiceProvider.dispose

  - Defined in src/di/ServiceProvider.ts:85

  #### Returns void

### get

- get<T>(key: IClassOf<T>): T

- Inherited from ServiceProvider.get

  - Defined in src/di/ServiceProvider.ts:25

  #### Type parameters

  - #### T

  #### Parameters

  - ##### key: IClassOf<T>

  #### Returns T

### getValue

- getValue(sd: ServiceDescription): any

- Inherited from ServiceProvider.getValue

  - Defined in src/di/ServiceProvider.ts:69

  #### Parameters

  - ##### sd: ServiceDescription

  #### Returns any

### installScript

- installScript(location: string): Promise<void>

- Inherited from WebApp.installScript

  - Defined in src/web/WebApp.ts:141

  #### Parameters

  - ##### location: string

  #### Returns Promise<void>

### installStyleSheet

- installStyleSheet(ssConfig: string | object): void

- Inherited from WebApp.installStyleSheet

  - Defined in src/web/WebApp.ts:112

  #### Parameters

  - ##### ssConfig: string | object

  #### Returns void

### Protected invokeReady

- invokeReady(): void

- Inherited from WebApp.invokeReady

  Overrides App.invokeReady

  - Defined in src/web/WebApp.ts:219

  #### Returns void

### main

- main(): void

- Overrides App.main

  - Defined in src/web/samples/demo/app.ts:7

  #### Returns void

### newScope

- newScope(): ServiceProvider

- Inherited from ServiceProvider.newScope

  - Defined in src/di/ServiceProvider.ts:81

  #### Returns ServiceProvider

### onError

- onError(error: any): void

- Inherited from App.onError

  - Defined in src/App.ts:127

  #### Parameters

  - ##### error: any

  #### Returns void

### Protected onReady

- onReady(f: function): void

- Inherited from App.onReady

  - Defined in src/App.ts:185

  #### Parameters

  - ##### f: function

    - - (): any

      - #### Returns any

  #### Returns void

### put

- put(key: any, value: any): void

- Inherited from ServiceProvider.put

  - Defined in src/di/ServiceProvider.ts:29

  #### Parameters

  - ##### key: any

  - ##### value: any

  #### Returns void

### resolve

- resolve<T>(key: T, create?: boolean, defValue?: IAnyInstanceType<T>): IAnyInstanceType<T>

- Inherited from ServiceProvider.resolve

  - Defined in src/di/ServiceProvider.ts:37

  #### Type parameters

  - #### T

  #### Parameters

  - ##### key: T

  - ##### Default value create: boolean = false

  - ##### Optional defValue: IAnyInstanceType<T>

  #### Returns IAnyInstanceType<T>

### runAsync

- runAsync<T>(tf: function): void

- Inherited from App.runAsync

  - Defined in src/App.ts:112

  This method will run any asynchronous method and it will display an error if it will fail asynchronously

  template

    T

  memberof

    AtomDevice

  #### Type parameters

  - #### T

  #### Parameters

  - ##### tf: function

    - - (): Promise<T>

      - #### Returns Promise<T>

  #### Returns void

### subscribe

- subscribe(channel: string, action: AtomAction): IDisposable

- Inherited from App.subscribe

  - Defined in src/App.ts:163

  Subscribe for given channel with action that will be executed when anyone will broadcast (this only works within the current browser window)

  This method returns a disposable, when you call `.dispose()` it will unsubscribe for current subscription

  memberof

    AtomDevice

  #### Parameters

  - ##### channel: string

  - ##### action: AtomAction

  #### Returns IDisposable

  Disposable that supports removal of subscription

### syncUrl

- syncUrl(): void

- Inherited from WebApp.syncUrl

  Overrides App.syncUrl

  - Defined in src/web/WebApp.ts:189

  Do not use this method

  #### Returns void

### updateDefaultStyle

- updateDefaultStyle(textContent: string): void

- Inherited from WebApp.updateDefaultStyle

  Overrides App.updateDefaultStyle

  - Defined in src/web/WebApp.ts:170

  #### Parameters

  - ##### textContent: string

  #### Returns void

### waitForPendingCalls

- waitForPendingCalls(): Promise<any>

- Inherited from App.waitForPendingCalls

  - Defined in src/App.ts:99

  #### Returns Promise<any>

Generated using TypeDoc